#!/usr/bin/perl

use strict;

# Check RTAcomplete.txt
# Check existence in AnalisysOutput

my $base = "/ccagc/lib/pipelines/TSACP/falco/misc";
my $getData = "$base/getData.pl";
my $startAn = "$base/startAnalysis.pl";

my $Project = shift or die "No project specified!\n";
my $AnalysisOutput = shift || "./"; #"/ccagc/data/SeqAnalysis/$Project";

my $MiSeqOutput = shift || "/ccagc/data/processing/MiSeqOutput/";


my $LOG = shift || "$AnalysisOutput/log/$Project.log";

if (! -d "$AnalysisOutput/log") {
	mkdir "$AnalysisOutput/log";
}

my %log = ();
open LOG, "<$LOG";
while (<LOG>) {
	chomp;
	# runDir date
	my @row = split(/\t/, $_);
	$log{$row[0]} = [@row];	
}
close LOG;

my @runs = `find $MiSeqOutput -maxdepth 2 -iname "RTAComplete.txt"`;
my %runHsh = ();

foreach my $r (@runs) {
	chomp;
	my $runDir = `dirname $r`;
	chomp $runDir;
	if (exists($log{$runDir})) {
		print STDERR "$runDir previously checked\n";
		next;
	}
	my @row = split(/\//, $runDir);
	my @run = split(/\_/, $row[$#row]);
	my $outDir = $AnalysisOutput . "/" . join("_", @run[0 .. 2]);
	my $baseDir = $AnalysisOutput;
	if (-e $outDir) {
		print STDERR "$outDir exists, skipping\n";
	} else {
		print STDERR "perl $getData $runDir $Project\n";
		system("perl $getData $runDir $Project $baseDir");
		print STDERR "perl $startAn $outDir\n";
		system("perl $startAn $outDir");
		open LOG, ">>$LOG";
		print LOG join("\t", $runDir, scalar(localtime())) . "\n";
		close LOG;
	}
}

